package com.its.op.service.its.vms;

import com.its.op.dao.repository.its.vms.TbVmsTypeRepository;
import com.its.op.dto.its.vms.TbVmsTypeDto;
import com.its.op.entity.its.vms.TbVmsType;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.Optional;

@Slf4j
@RequiredArgsConstructor
@Service
public class TbVmsTypeService {

    private final TbVmsTypeRepository repo;

    // 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbVmsTypeDto> findAll() {
        List<TbVmsTypeDto> result = new ArrayList<>();
        List<TbVmsType> data = this.repo.findAll();
        for (TbVmsType entity : data) {
            if (("Y").equals(entity.getUseYn())) {
                result.add(entity.toDto());
            }
        }
        return result;
    }

    // 데이터 변경 또는 생성-목록(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public List<TbVmsTypeDto> mergeInfoList(List<TbVmsTypeDto.TbVmsTypeUpdReq> reqList) {
        List<TbVmsTypeDto> result = new ArrayList<>();
        for (TbVmsTypeDto.TbVmsTypeUpdReq req : reqList) {
            TbVmsType obj = req.toEntity();
            this.repo.save(obj);
            result.add(obj.toDto());
        }
        return result;
    }

    // 데이터 변경 또는 생성-개별(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public TbVmsTypeDto mergeInfo(TbVmsTypeDto.TbVmsTypeUpdReq req) {
        TbVmsType obj = req.toEntity();
        this.repo.save(obj);
        return obj.toDto();
    }

    // 정보 삭제-목록, 존재하는 데이터 만 삭제
    @Transactional
    public List<TbVmsTypeDto> deleteByIds(List<String> ids) {
        List<TbVmsTypeDto> result = new ArrayList<>();
        for (String id : ids) {
            Optional<TbVmsType> obj = this.repo.findById(id);
            if (obj.isPresent()) {
                this.repo.deleteById(id);
                result.add(obj.get().toDto());
            }
        }
        return result;
    }

}
